package com.antlersoft.dvarchfix;

/**
 * <p>Title: FixSetStartPos</p>
 * <p>Description: </p>
 * <p>Copyright (c) 2003  Michael A. MacDonald<p>
 * ----- - - -- - - --
 * <p>
 * Permission to use, copy, modify and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice and this
 * permission notice appear in all copies and supporting
 * documentation, and that the names Michael MacDonald or
 * antlersoft not be used in advertising or publicity pertaining
 * to distribution of the software. Michael A. MacDonald makes no
 * representations about the suitability of this software for any
 * purpose. It is provided "as is" without express or implied
 * warranty.
 * <p>
 * Michael A. MacDonald  DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
 * Michael A. MacDonald BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * <p>
 * ----- - - -- - - --
 * <p>Company: antlersoft</p>
 * @author Michael Macdonald
 * @version 1.0
 */

import java.io.*;
import java.util.*;
import com.antlersoft.classwriter.*;

public class FixSetStartPos
{
    public static void main(String[] args)
    throws Exception
    {
        FileInputStream is=new FileInputStream( args[0]);
        ClassWriter w=new ClassWriter();
        w.readClass( is);
        for ( Iterator i=w.getMethods().iterator(); i.hasNext();)
        {
            MethodInfo method=(MethodInfo)i.next();
System.out.println( method.getName()+method.getType());
            if ( method.getName().equals( "setSourceFilename")
                && method.getType().indexOf( "JJ")!= -1)
           {
               System.out.println( "Method found");
               CodeAttribute code=method.getCodeAttribute();
               ArrayList instructions=new ArrayList();
               byte[] arg=new byte[1];
               arg[0]=4;
               Instruction.addNextInstruction( instructions, "lload", arg, false);
               code.insertInstructions( 44, 2, instructions);
System.out.println( code.getMaxStack());
               code.codeCheck();
System.out.println( code.getMaxStack());
               break;
           }
        }
        FileOutputStream os=new FileOutputStream( args[1]);
        w.writeClass( os);
        os.close();
    }
}
